/**********
This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**********/
// Copyright (c) 1996-2000 Live Networks, Inc.  All rights reserved.
// Usage Environment
// Implementation

#include "UsageEnvironment.hh"
#include <stdio.h>
#include <time.h>
#include <sys/timeb.h>

Boolean UsageEnvironment::reclaim(Boolean force/* = False*/) {
  // We delete ourselves only if we have no remainining state:
  struct timeb tp;
  struct tm stm;
  ftime(&tp);
  localtime_r(&tp.time, &stm);
  if (True == force)
  {
      Boolean ret = (liveMediaPriv == NULL && groupsockPriv == NULL);
      fprintf(stderr, "[%d:%d:%d] UsageEnvironment::reclaim(TRUE)\n",
          stm.tm_hour, stm.tm_min, stm.tm_sec);
      delete this;
      return ret;
  }
  else if (liveMediaPriv == NULL && groupsockPriv == NULL)
  {
      delete this;
      fprintf(stderr, "[%d:%d:%d] UsageEnvironment::reclaim(): reclaim() with delete!!\n",
          stm.tm_hour, stm.tm_min, stm.tm_sec);
      return True;
  }
  else
  {
      fprintf(stderr, "[%d:%d:%d] UsageEnvironment::reclaim(): I should delete myself but I can't!"
          " liveMediaPriv(%p), groupsockPriv(%p)\n",
          stm.tm_hour, stm.tm_min, stm.tm_sec, liveMediaPriv, groupsockPriv);
      return False;
  }
}

UsageEnvironment::UsageEnvironment(TaskScheduler& scheduler)
  : liveMediaPriv(NULL), groupsockPriv(NULL), fScheduler(scheduler), userData(NULL), userDataLen(0) {
}

UsageEnvironment::~UsageEnvironment() {
}

TaskScheduler::TaskScheduler() {
}

TaskScheduler::~TaskScheduler() {
}
 
void TaskScheduler::rescheduleDelayedTask(TaskToken& task,
					  int64_t microseconds, TaskFunc* proc,
					  void* clientData) {
  unscheduleDelayedTask(task);
  task = scheduleDelayedTask(microseconds, proc, clientData);
}
